﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace rizeni_v1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            sp_list.DataSource = SerialPort.GetPortNames();//načtení portů
            lbl_error.Text = "";//čištění textových polí
            lbl_command.Text = "";
        }
                
        private void btn_open_close_Click(object sender, EventArgs e)
        {
            if (serialp.IsOpen==true)//kontrola otevření portu
            {
                serialp.Close();
                btn_open_close.Text = "Otevřít port";
                log.Items.Add(DateTime.Now + " " + sp_list.SelectedItem + " byl zavřen");
            }
            else
            {
                try
                {
                    serialp.PortName = sp_list.SelectedItem as String;
                }
                catch (ArgumentNullException ex)//výjímka - žádné porty
                {
                    log.Items.Add(DateTime.Now + " Připojte zařízení");
                    return;
                }
                
                try
                {
                    serialp.Open();
                    btn_open_close.Text = "Zavřít port";
                    log.Items.Add(DateTime.Now + " " + sp_list.SelectedItem + " byl otevřen");
                    if (lbl_error.Text == "Zavřený port")
                        lbl_error.Text = "";
                }
                catch (UnauthorizedAccessException d)//výjimka - nepřístupný port
                {
                    log.Items.Add(DateTime.Now + " " + sp_list.SelectedItem + " je nepřístupný");
                }

                }
        }       

        private void btn_run_x_Click(object sender, EventArgs e)
        {            
            string dir = "";    
            if (serialp.IsOpen==false)//kontrola otevření portu
            {
                lbl_error.Text = "Zavřený port";
                return;
            }            
            if (radioButton1.Checked)//čtení směru
                dir = "0";
            else if (radioButton2.Checked)
                dir = "1";           
            string odeslat="7;R2"+"2"+dir +"0" +tb_speed_x.Text+"1";//vytvoření zprávy
            serialp.DiscardInBuffer();//vyčištění vstupních zpráv
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;            
            log.Items.Add(DateTime.Now+" "+odeslat);//záznam zprávy
            Thread.Sleep(10);
            string prijem = serialp.ReadExisting();//příjem zprávy            
            log.Items.Add(DateTime.Now + " " + prijem);//záznam zprávy
        }

        private void btn_clear_Click(object sender, EventArgs e)
        {
            lbl_error.Text = "";
        }

        private void tb_speed_x_TextChanged(object sender, EventArgs e)
        {
            int a = 0;

            if (int.TryParse(tb_speed_x.Text, out a) == false)//kontrola zadání čísla
            {
                lbl_error.Text = "Špatně zadaná hodnota";
                tb_speed_x.Text = "0";
            }
            else
            {
                if ((int.Parse(tb_speed_x.Text) < 0) || (int.Parse(tb_speed_x.Text) > 9))//kontrola čísla v intervalu
                {
                    lbl_error.Text = "Zadejte číslo 0 až 9";
                    tb_speed_x.Text = "0";
                }
            }
            track_x.Value = int.Parse(tb_speed_x.Text);//překlopení hodnoty z pole na jezdec        

        }

        private void track_x_Scroll(object sender, EventArgs e)
        {
            tb_speed_x.Text = track_x.Value.ToString();//překlopení hodnoty z jezce do pole
        }

        private void btn_run_y_Click(object sender, EventArgs e)
        {
            string dir = "";
            if (serialp.IsOpen == false)//kontrola otevření portu
            {
                lbl_error.Text = "Zavřený port";
                return;
            }
            if (radioButton3.Checked)//čtení směru
                dir = "0";
            else if (radioButton4.Checked)
                dir = "1";
            string odeslat = "7;R1"  + dir +"2"+  tb_speed_y.Text + "01";//vytvoření zprávy
            serialp.DiscardInBuffer();//vyčištění vstupních zpráv
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;            
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
            Thread.Sleep(10);
            string prijem=serialp.ReadExisting();//příjem zprávy
            log.Items.Add(DateTime.Now + " " + prijem);//záznam zprávy
        }

        private void tb_speed_y_TextChanged(object sender, EventArgs e)
        {
            int a = 0;

            if (int.TryParse(tb_speed_y.Text, out a) == false)//kontrola zadání čísla
            {
                lbl_error.Text = "Špatně zadaná hodnota";
                tb_speed_y.Text = "0";
            }
            else
            {
                if ((int.Parse(tb_speed_y.Text) < 0) || (int.Parse(tb_speed_y.Text) > 9))//kontrola čísla v intervalu
                {
                    lbl_error.Text = "Zadejte číslo 0 až 9";
                    tb_speed_y.Text = "0";
                }
            }
            track_y.Value = int.Parse(tb_speed_y.Text);//překlopení hodnoty z pole na jezdec
        }

        private void track_y_Scroll(object sender, EventArgs e)
        {
            tb_speed_y.Text = track_y.Value.ToString();//překlopení hodnoty z jezce do pole
        }

        private void btn_run_r_Click(object sender, EventArgs e)
        {
            string dir = "";
            if (serialp.IsOpen == false)//kontrola otevření portu
            {
                lbl_error.Text = "Zavřený port";
                return;
            }
            if (radioButton5.Checked)//čtení směru
                dir = "0";
            else if (radioButton6.Checked)
                dir = "1";
            string odeslat = "7;R2" + "0" + dir + "0" + tb_speed_r.Text + "0";//vytvoření zprávy
            serialp.DiscardInBuffer();//vyčištění vstupních zpráv
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
            Thread.Sleep(10);
            string prijem = serialp.ReadExisting();//příjem zprávy
            log.Items.Add(DateTime.Now + " " + prijem);//záznam zprávy
        }

        private void tb_speed_r_TextChanged(object sender, EventArgs e)
        {
            int a = 0;

            if (int.TryParse(tb_speed_r.Text, out a) == false)//kontrola zadání čísla
            {
                lbl_error.Text = "Špatně zadaná hodnota";
                tb_speed_r.Text = "0";
            }
            else
            {
                if ((int.Parse(tb_speed_r.Text) < 0) || (int.Parse(tb_speed_r.Text) > 9))//kontrola čísla v intervalu
                {
                    lbl_error.Text = "Zadejte číslo 0 až 9";
                    tb_speed_r.Text = "0";
                }
            }
            track_r.Value = int.Parse(tb_speed_r.Text);//překlopení hodnoty z pole na jezdec
        }

        private void track_r_Scroll(object sender, EventArgs e)
        {
            tb_speed_r.Text = track_r.Value.ToString();//překlopení hodnoty z jezce do pole
        }

        private void btn_help_Click(object sender, EventArgs e)
        {            
            System.Diagnostics.Process.Start(Environment.CurrentDirectory+"/prikazy.txt");//otevření txt se zprávami
        }

        private void btn_stop_x_Click(object sender, EventArgs e)
        {
            if (serialp.IsOpen == false)//kontrola otevření portu
            {
                lbl_error.Text = "Zavřený port";
                return;
            }
            string odeslat = "3;S21";//vytvoření zprávy
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
        }

        private void btn_stop_y_Click(object sender, EventArgs e)
        {
            if (serialp.IsOpen == false)//kontrola otevření portu
            {
                lbl_error.Text = "Zavřený port";
                return;
            }
            string odeslat = "3;S11";//vytvoření zprávy
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
        }

        private void btn_HiZ_x_Click(object sender, EventArgs e)
        {
            if (serialp.IsOpen == false)//kontrola otevření portu
            {
                lbl_error.Text = "Zavřený port";
                return;
            }
            string odeslat = "3;Z21";//vytvoření zprávy
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
        }

        private void btn_HiZ_y_Click(object sender, EventArgs e)
        {
            if (serialp.IsOpen == false)//kontrola otevření portu
            {
                lbl_error.Text = "Zavřený port";
                return;
            }
            string odeslat = "3;Z11";//vytvoření zprávy
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
        }

        private void btn_move_x_Click(object sender, EventArgs e)
        {            
            string dir = "";
            if (serialp.IsOpen == false)//kontrola otevření portu
            {
                lbl_error.Text = "Zavřený port";
                return;
            }
            string odeslat = "5;SS12" + tb_speed_x.Text;//vytvoření zprávy (Maximální rychlost - čtení z pole Run)
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
            Thread.Sleep(5);
            if (radioButton1.Checked)//čtení směru
                dir = "0";
            else if (radioButton2.Checked)
                dir = "1";
            int extra_delka = 0;
            int p = int.Parse(tb_steps_x.Text);
            while (p != 0)//výpočet o kolik bude zpráva delší oproti základu
            {
                p = p / 10;
                extra_delka++;
            }
            odeslat = (8+extra_delka)+";M22"+dir+"10;"+tb_steps_x.Text+";";//vytvoření zprávy
            serialp.DiscardInBuffer();//vyčištění vstupních zpráv
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
            Thread.Sleep(10);
            string prijem = serialp.ReadExisting();//příjem zprávy
            log.Items.Add(DateTime.Now + " " + prijem);//záznam zprávy
        }

        private void tb_steps_x_TextChanged(object sender, EventArgs e)
        {
            int a = 0;

            if (int.TryParse(tb_steps_x.Text, out a) == false)//kontrola zadání čísla
            {
                lbl_error.Text = "Špatně zadaná hodnota";
                tb_steps_x.Text = "0";
            }
            else
            {
                if ((int.Parse(tb_steps_x.Text) < 0) || (int.Parse(tb_steps_x.Text) > 4194303))//kontrola čísla v intervalu
                {
                    lbl_error.Text = "Zadejte kladné číslo \n menší než 4194303";
                    tb_steps_x.Text = "0";
                }
            }
            
        }

        private void btn_move_y_Click(object sender, EventArgs e)
        {            
            string dir = "";
            if (serialp.IsOpen == false)//kontrola otevření portu
            {
                lbl_error.Text = "Zavřený port";
                return;
            }
            string odeslat = "5;SS11" + tb_speed_y.Text;//vytvoření zprávy (Maximální rychlost - čtení z pole Run)
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
            Thread.Sleep(5);
            if (radioButton3.Checked)//čtení směru
                dir = "0";
            else if (radioButton4.Checked)
                dir = "1";
            int extra_delka = 0;
            int p = int.Parse(tb_steps_y.Text);
            while (p != 0)//výpočet o kolik bude zpráva delší oproti základu
            {
                p = p / 10;
                extra_delka++;
            }
            odeslat = (8+extra_delka)+";M1" + dir +"21" + tb_steps_y.Text+";0;";//vytvoření zprávy
            serialp.DiscardInBuffer();//vyčištění vstupních zpráv
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
            Thread.Sleep(10);
            string prijem = serialp.ReadExisting();//příjem zprávy
            log.Items.Add(DateTime.Now + " " + prijem);//záznam zprávy
        }

        private void tb_steps_y_TextChanged(object sender, EventArgs e)
        {
            int a = 0;

            if (int.TryParse(tb_steps_y.Text, out a) == false)//kontrola zadání čísla
            {
                lbl_error.Text = "Špatně zadaná hodnota";
                tb_steps_y.Text = "0";
            }
            else
            {
                if ((int.Parse(tb_steps_y.Text) < 0) || (int.Parse(tb_steps_y.Text) > 4194303))//kontrola čísla v intervalu
                {
                    lbl_error.Text = "Zadejte kladné číslo \n menší než 4194303";
                    tb_steps_y.Text = "0";
                }
            }
            
        }

        private void btn_clear_log_Click(object sender, EventArgs e)
        {
            log.Items.Clear();
        }

        private void btn_goto_Click(object sender, EventArgs e)
        {
            if (serialp.IsOpen == false)//kontrola otevření portu
            {
                lbl_error.Text = "Zavřený port";
                return;
            }
            string odeslat = "5;SS12" + tb_speed_x.Text;//vytvoření zprávy (Maximální rychlost - čtení z pole Run)
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
            Thread.Sleep(5);
            odeslat = "5;SS11" + tb_speed_y.Text;//vytvoření zprávy (Maximální rychlost - čtení z pole Run)
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
            Thread.Sleep(5);
            odeslat = "5;SS02" + tb_speed_r.Text;//vytvoření zprávy (Maximální rychlost - čtení z pole Run)
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
            Thread.Sleep(5);
            string pozice_x = "";
            string pozice_y = "";
            string pozice_r = "";
            odeslat = "";
            int extra_delka = 0;
            int p_x =0;
            int p_y = 0;
            int p_r = 0;
            pozice_x=(int.Parse(tb_pozice_x.Text)*800).ToString();//přepočet pro osu x
            pozice_y = (int.Parse(tb_pozice_y.Text) * 800).ToString();//přepočet pro osu y
            if (tb_pozice_r.Text == "0")
                pozice_r = (int.Parse(tb_pozice_r.Text) + 1160).ToString();//přepočet pro rameno (úhel 0°)
            else
            pozice_r = (1160 + int.Parse(tb_pozice_r.Text) * 82).ToString();//přepočet pro rameno (úhel > 0°)
            p_x = int.Parse(pozice_x);
            while (p_x >= 10)//výpočet o kolik bude zpráva delší oproti základu (osa x)
            {
                p_x = p_x / 10;
                extra_delka++;
            }
            p_y = int.Parse(pozice_y);//výpočet o kolik bude zpráva delší oproti základu (osa y)
            while (p_y >= 10)
            {
                p_y = p_y / 10;
                extra_delka++;
            }
            odeslat = (8+extra_delka)+";GT01" + pozice_y + ";" + pozice_x + ";";//vytvoření zprávy pro kameru
            serialp.DiscardInBuffer();//vyčištění vstupních zpráv
            serialp.Write(odeslat);//odeslání zprávy
            Thread.Sleep(10);
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
            string prijem = serialp.ReadExisting();//příjem zprávy
            log.Items.Add(DateTime.Now + " " + prijem);//záznam zprávy
            p_r = int.Parse(pozice_r);
            extra_delka = 0;
            while (p_r >= 10)//výpočet o kolik bude zpráva delší oproti základu (rameno)
            {
                p_r = p_r / 10;
                extra_delka++;
            }
            odeslat = (8+extra_delka) + ";GT200;" + pozice_r + ";";//vytvoření zprávy pro rameno
            Thread.Sleep(5);
            serialp.Write(odeslat);//odeslání zprávy
            Thread.Sleep(10);
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
            prijem = serialp.ReadExisting();//příjem zprávy
            log.Items.Add(DateTime.Now + " " + prijem);//záznam zprávy
        }

        private void tb_pozice_x_TextChanged(object sender, EventArgs e)
        {
            int a = 0;

            if (int.TryParse(tb_pozice_x.Text, out a) == false)//kontrola zadání čísla
            {
                lbl_error.Text = "Špatně zadaná hodnota";
                tb_pozice_x.Text = "0";
            }
            else
            {
                if ((int.Parse(tb_pozice_x.Text) < 0) || (int.Parse(tb_pozice_x.Text) > 383))//kontrola čísla v intervalu
                {
                    lbl_error.Text = "Zadejte kladné číslo \n menší než 383";
                    tb_pozice_x.Text = "0";
                }
            }
            track_x_p.Value = int.Parse(tb_pozice_x.Text);//překlopení hodnoty z pole na jezdec
        }

        private void tb_pozice_y_TextChanged(object sender, EventArgs e)
        {
            int a = 0;

            if (int.TryParse(tb_pozice_y.Text, out a) == false)//kontrola zadání čísla
            {
                lbl_error.Text = "Špatně zadaná hodnota";
                tb_pozice_y.Text = "0";
            }
            else
            {
                if ((int.Parse(tb_pozice_y.Text) < 0) || (int.Parse(tb_pozice_y.Text) > 353))//kontrola čísla v intervalu
                {
                    lbl_error.Text = "Zadejte kladné číslo \n menší než 353";
                    tb_pozice_y.Text = "0";
                }
            }
            track_y_p.Value = int.Parse(tb_pozice_y.Text);//překlopení hodnoty z pole na jezdec
        }

        private void btn_mover_Click(object sender, EventArgs e)
        {            
            string dir = "";
            if (serialp.IsOpen == false)//kontrola otevření portu
            {
                lbl_error.Text = "Zavřený port";
                return;
            }
            string odeslat = "5;SS02" + tb_speed_r.Text;//vytvoření zprávy (Maximální rychlost - čtení z pole Run)
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
            Thread.Sleep(5);
            if (radioButton5.Checked)//čtení směru
                dir = "0";
            else if (radioButton6.Checked)
                dir = "1";
            int extra_delka = 0;
            int p = int.Parse(tb_stepsr.Text);
            while (p != 0)//výpočet o kolik bude zpráva delší oproti základu
            {
                p = p / 10;
                extra_delka++;
            }
            odeslat = (8 + extra_delka) + ";M2" + "2"+dir+  "0" + "0;" + tb_stepsr.Text +";";//vytvoření zprávy
            serialp.DiscardInBuffer();//vyčištění vstupních zpráv
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
            Thread.Sleep(10);
            string prijem = serialp.ReadExisting();//příjem zprávy
            log.Items.Add(DateTime.Now + " " + prijem);//záznam zprávy
        }

        private void btn_stop_r_Click(object sender, EventArgs e)
        {
            if (serialp.IsOpen == false)//kontrola otevření portu
            {
                lbl_error.Text = "Zavřený port";
                return;
            }
            string odeslat = "3;S20";//vytvoření zprávy
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
        }

        private void track_x_p_Scroll(object sender, EventArgs e)
        {
            tb_pozice_x.Text = track_x_p.Value.ToString();//překlopení hodnoty z jezce do pole
        }

        private void track_y_p_Scroll(object sender, EventArgs e)
        {
            tb_pozice_y.Text = track_y_p.Value.ToString();//překlopení hodnoty z jezce do pole
        }

        private void btn_HiZ_r_Click(object sender, EventArgs e)
        {
            if (serialp.IsOpen == false)//kontrola otevření portu
            {
                lbl_error.Text = "Zavřený port";
                return;
            }
            string odeslat = "3;Z20";//vytvoření zprávy
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
        }

        private void btn_scan_Click(object sender, EventArgs e)
        {
            sp_list.DataSource = SerialPort.GetPortNames();//sken portů
        }

        private void tb_pozice_r_TextChanged(object sender, EventArgs e)
        {
            int a = 0;

            if (int.TryParse(tb_pozice_r.Text, out a) == false)//kontrola zadání čísla
            {
                lbl_error.Text = "Špatně zadaná hodnota";
                tb_pozice_r.Text = "0";
            }
            else
            {
                if ((int.Parse(tb_pozice_r.Text) < 0) || (int.Parse(tb_pozice_r.Text) > 180))//kontrola čísla v intervalu
                {
                    lbl_error.Text = "Zadejte úhel \n mezi 0 a 180";
                    tb_pozice_r.Text = "0";
                }
            }
            
            track_r_p.Value = int.Parse(tb_pozice_r.Text);//překlopení hodnoty z pole na jezdec
        }

        private void track_r_p_Scroll(object sender, EventArgs e)
        {
            tb_pozice_r.Text = track_r_p.Value.ToString();//překlopení hodnoty z jezce do pole
        }

        private void btn_stop_Click(object sender, EventArgs e)
        {
            if (serialp.IsOpen == false)//kontrola otevření portu
            {
                lbl_error.Text = "Zavřený port";
                return;
            }
            string odeslat = "3;S01";//vytvoření zprávy pro kameru
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy
            odeslat = "3;S20";//vytvoření zprávy pro rameno
            Thread.Sleep(5);
            serialp.Write(odeslat);//odeslání zprávy
            lbl_command.Text = odeslat;
            log.Items.Add(DateTime.Now + " " + odeslat);//záznam zprávy

        }

        private void label17_Click(object sender, EventArgs e)
        {

        }

        private void lbl_smerr_Click(object sender, EventArgs e)
        {

        }
    }
}
