
#include "stm32f4xx.h"
#include <stdio.h>
#define nCS_kamera_low GPIOA->ODR&=~(GPIO_ODR_ODR_4)//ovldn CS
#define nCS_kamera_high GPIOA->ODR|=GPIO_ODR_ODR_4
#define nCS_rameno_low GPIOA->ODR&=~(GPIO_ODR_ODR_10)
#define nCS_rameno_high GPIOA->ODR|=GPIO_ODR_ODR_10
#define kamera 1
#define rameno 0

volatile int tick=0;//promnn pro asova
int prijem1=1;//promnn pro pjem
int prijem2=1;
int prijem3=1;
int prijem4=1;
int prijem5=1;
int prijem6=1;
int prijem7=1;
int Run_kamera_speeds[10]={8,16,24,32,40,48,56,64,72,80};//pole rychlost pro pkaz Run - kamera
int Run_rameno_speeds[10]={0,1,2,3,4,5,6,7,8,9};//pole rychlost pro pkaz Run - rameno
void SysTick_Handler(void) //systmov asova
{
	tick++;

}
void LedInit()
{
	RCC->AHB1RSTR|=RCC_AHB1RSTR_GPIOARST;//RESET GPIO port
	RCC->AHB1RSTR&=~(RCC_AHB1RSTR_GPIOARST);
	RCC->AHB1RSTR|=RCC_AHB1RSTR_GPIOCRST;
	RCC->AHB1RSTR&=~(RCC_AHB1RSTR_GPIOCRST);
	RCC->AHB1RSTR|=RCC_AHB1RSTR_GPIOBRST;
	RCC->AHB1RSTR&=~(RCC_AHB1RSTR_GPIOBRST);
	RCC->AHB1ENR|=RCC_AHB1ENR_GPIOAEN;//povolen GPIO port
	RCC->AHB1ENR|=RCC_AHB1ENR_GPIOCEN;
	RCC->AHB1ENR|=RCC_AHB1ENR_GPIOBEN;
	GPIOA->MODER|=GPIO_MODER_MODER5_0;//LED GREEN
	//GPIOC->MODER|=GPIO_MODER_MODER0_0;//LED YELLOW
	//GPIOC->MODER|=GPIO_MODER_MODER1_0;//LED RED
}
void SpinaceInit()//piny pro spnae defaultn nastaveny na vstup, tzn. neteba nastavovat
{
	//GPIOC->MODER|=GPIO_MODER_MODER
}
void SPIInit()//inicializace SPI
{
	//SPI GPIO
	GPIOA->MODER|=GPIO_MODER_MODER7_1;//AF - Alternativn funkce
	GPIOA->MODER|=GPIO_MODER_MODER6_1;//AF
	GPIOB->MODER|=GPIO_MODER_MODER3_1;//AF
	GPIOA->MODER|=GPIO_MODER_MODER4_0;//OUT_CS_kamera - nastaven pinu na vstup pro CS
	GPIOA->MODER|=GPIO_MODER_MODER10_0;//OUT_CS_rameno
	GPIOA->ODR|=GPIO_ODR_ODR_4;//CS_kamera HIGH - nastaven CS do "1"
	GPIOA->ODR|=GPIO_ODR_ODR_10;//CS_rameno HIGH
	GPIOA->OSPEEDR|=(3<<14);//HIGH - vysok rychlost pinu
	GPIOA->OSPEEDR|=(3<<12);//HIGH
	GPIOB->OSPEEDR|=(3<<6);//HIGH
	GPIOA->OSPEEDR|=(3<<8);//HIGH
	GPIOA->AFR[0]|=(5<<28);//MOSI
	GPIOA->AFR[0]|=(5<<24);//MISO
	GPIOB->AFR[0]|=(5<<12);//SCK

	RCC->APB2RSTR|=RCC_APB2RSTR_SPI1;//hodiny SPI1 reset
	RCC->APB2RSTR&=~(RCC_APB2RSTR_SPI1);
	RCC->APB2ENR|=RCC_APB2ENR_SPI1EN;//povolen hodin pro SPI1

	SPI1->CR1|=SPI_CR1_BR_0|SPI_CR1_MSTR|SPI_CR1_SSI|SPI_CR1_SSM|SPI_CR1_CPOL|SPI_CR1_CPHA;//konfigurace SPI1
	SPI1->CR1|=SPI_CR1_SPE;//povolen SPI1
}
//		Forma pkazu pro budie
//			1. CS do "0"
//			2. odesln pkazu/dat pro jeden budi
//			3. ekn na odesln
//			(ppadn pjem)
//			4. odesln pkazu/dat pro druh budi
//			5. ekn na odesln
//			(ppadn pjem)
//			6. CS do "1"
//			(opakovn od 1.)
void Run(int motor, int dir1, int dir2,int speed1, int speed2, int nCS)//odesln pkazu RUN
{
	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
		SPI1->DR=0;
	else
	{if(dir1==0)//vbr smru motoru - 1. motor
		SPI1->DR=80;//RUN command byte
	else
		SPI1->DR=81;
	}
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(motor==1)//vbr budie v modulu
		SPI1->DR=0;
	else
	{if(dir2==0)//vbr smru motoru - 2. motor
		SPI1->DR=80;//RUN command byte
	else
		SPI1->DR=81;
	}
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	while(!(SPI1->SR & SPI_SR_RXNE))//ekn na pjem - zde pjem nepodstatn
		prijem1=SPI1->DR;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	SPI1->DR=0;//SPEED byte 2 - moc velk rychlost
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	SPI1->DR=0;//SPEED byte 2 - moc velk rychlost
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	while(!(SPI1->SR & SPI_SR_RXNE))//ekn na pjem - zde pjem nepodstatn
		prijem2=SPI1->DR;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
		SPI1->DR=0;
	else
		{if(nCS==kamera)//vbr pslunho pole rychlost - 1. motor
			SPI1->DR=Run_kamera_speeds[speed1];//SPEED byte 1
		else if(nCS==rameno)
			SPI1->DR=Run_rameno_speeds[speed1];//SPEED byte 1
		}
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
	;
	if(motor==1)//vbr budie v modulu
		SPI1->DR=0;
	else
		{if(nCS==kamera)//vbr pslunho pole rychlost - 2. motor
			SPI1->DR=Run_kamera_speeds[speed2];//SPEED byte 1
		else if(nCS==rameno)
			SPI1->DR=Run_rameno_speeds[speed2];//SPEED byte 1
		}
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	while(!(SPI1->SR & SPI_SR_RXNE))//ekn na pjem - zde pjem nepodstatn
		prijem3=SPI1->DR;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
		SPI1->DR=0;
	else
		SPI1->DR=255;//SPEED byte 0, 1. motor, vdy 255 - zpsob mal rozdl
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(motor==1)//vbr budie v modulu
		SPI1->DR=0;
	else
		SPI1->DR=255;//SPEED byte 0, 2. motor, vdy 255 - zpsob mal rozdl
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	while(!(SPI1->SR & SPI_SR_RXNE))//ekn na pjem - zde pjem nepodstatn
		prijem4=SPI1->DR;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;
}
void Set_OCD(int nCS)//overcurrent detection, nepouv se
{
	if(nCS==1)
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	SPI1->DR=19;
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))
		;
	SPI1->DR=19;
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))
		;
	if(nCS==1)
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	nCS_kamera_low;
	SPI1->DR=4;//1875mA
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))
		;
	SPI1->DR=4;
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))
		;
	if(nCS==1)
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;
}
void Set_Stall(int nCS)//stall detection, nepouv se
{
	if(nCS==1)
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	SPI1->DR=20;
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))
		;
	SPI1->DR=20;
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))
		;
	if(nCS==1)
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;
	if(nCS==1)
			nCS_kamera_low;
	else if(nCS==0)
			nCS_rameno_low;
	SPI1->DR=51;//1625mA
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))
		;
	SPI1->DR=51;
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))
		;
	if(nCS==1)
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;
}
void Soft_HiZ(int motor ,int nCS)//soft high Z
{
	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=160;//SoftHiZ command byte
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(motor==1)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=160;//SoftHiZ command byte
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;
}
void Move(int motor,int dir1, int dir2, int nCS, int steps1, int steps2)
{
	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
		SPI1->DR=0;
	else
	{
		if(dir1==0)//vbr smru motoru - 1. motor
			SPI1->DR=64;//DIR=0
		else
			SPI1->DR=65;
	}
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(motor==1)//vbr budie v modulu
		SPI1->DR=0;
	else
	{
		if(dir2==0)//vbr smru motoru - 2. motor
			SPI1->DR=64;//DIR=0
		else
			SPI1->DR=65;
	}
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=(steps1>>16);//N_STEP BYTE 2 - poet krok byte 2
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(motor==1)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=(steps2>>16);//N_STEP BYTE 2 - poet krok byte 2
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=((steps1>>8)&(0xFF));//N_STEP BYTE 1 - poet krok byte 1
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(motor==1)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=((steps2>>8)&(0xFF));//N_STEP BYTE 1 - poet krok byte 1
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=(steps1&0xFF);//N_STEP BYTE 0 - poet krok byte 0
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(motor==1)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=(steps2&0xFF);//N_STEP BYTE 0 - poet krok byte 0
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;
}
void SoftStop(int motor,int nCS)//soft stop command
{
	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=176;//Soft stop command byte
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(motor==1)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=176;//Soft stop command byte
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;
}
void GetStatus(int nCS)//Get Status command
{
	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	SPI1->DR=208;//Get Status command byte
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	prijem7=SPI1->DR;//vyten pjmu, aby ped pijmanm dat byl registr voln
	SPI1->DR=208;//Get Status command byte
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	prijem7=SPI1->DR;//vyten pjmu, aby ped pijmanm dat byl registr voln
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	SPI1->DR=0;//przdn pkaz, pro generovn hodinovch puls
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	while(!(SPI1->SR & SPI_SR_RXNE))//ekn na pjem - lze vynechat
		;
	prijem1=SPI1->DR;//pjem dat
	SPI1->DR=0;//przdn pkaz, pro generovn hodinovch puls
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	while(!(SPI1->SR & SPI_SR_RXNE))//ekn na pjem - lze vynechat
		;
	prijem2=SPI1->DR;//pjem dat
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	SPI1->DR=0;//przdn pkaz, pro generovn hodinovch puls
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	prijem3=SPI1->DR;//pjem dat
	SPI1->DR=0;//przdn pkaz, pro generovn hodinovch puls
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	prijem4=SPI1->DR;//pjem dat
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	SPI1->DR=0;//przdn pkaz, pro generovn hodinovch puls
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	prijem5=SPI1->DR;//pjem dat
	SPI1->DR=0;//przdn pkaz, pro generovn hodinovch puls
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	prijem6=SPI1->DR;//pjem dat
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;
}
void GetParam(int address, int nCS)//Get Param command
{
	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	SPI1->DR=address;//adresa registru spolen + 32 (oznaen pkazu)
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	prijem7=SPI1->DR;//vyten pjmu, aby ped pijmanm dat byl registr voln
	SPI1->DR=address;//adresa registru spolen + 32 (oznaen pkazu)
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	prijem7=SPI1->DR;//vyten pjmu, aby ped pijmanm dat byl registr voln
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	SPI1->DR=0;//przdn pkaz, pro generovn hodinovch puls
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	prijem1=SPI1->DR;//pjem dat
	SPI1->DR=0;//przdn pkaz, pro generovn hodinovch puls
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	prijem2=SPI1->DR;//pjem dat
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	SPI1->DR=0;//przdn pkaz, pro generovn hodinovch puls
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	prijem3=SPI1->DR;//pjem dat
	SPI1->DR=0;//przdn pkaz, pro generovn hodinovch puls
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	prijem4=SPI1->DR;//pjem dat
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	SPI1->DR=0;//przdn pkaz, pro generovn hodinovch puls
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	prijem5=SPI1->DR;//pjem dat
	SPI1->DR=0;//przdn pkaz, pro generovn hodinovch puls
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	prijem6=SPI1->DR;//pjem dat
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;
}
void SetMaxSpeed(int speed, int nCS, int motor)//Set max speed command
{
	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=7;//SetMaxSpeed command byte (respektive varianta pkazu Setparam)
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(motor==1)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=7;//SetMaxSpeed command byte (respektive varianta pkazu Setparam)
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	//MSB
	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
			SPI1->DR=0;
		else
	SPI1->DR=(speed>>8);//Max speed byte 1
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(motor==1)//vbr budie v modulu
			SPI1->DR=0;
		else
	SPI1->DR=(speed>>8);//Max speed byte 1
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
			SPI1->DR=0;
		else
	SPI1->DR=(speed&0x0FF);//Max speed byte 0
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(motor==1)//vbr budie v modulu
			SPI1->DR=0;
		else
	SPI1->DR=(speed&0x0FF);//Max speed byte 0
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;
}
void SetStepMode(int mode, int nCS)//Set step mode command, nepouv se
{
	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	SPI1->DR=22;//Step mode command byte(respektive varianta pkazu Setparam)
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	SPI1->DR=22;//Step mode command byte(respektive varianta pkazu Setparam)
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	SPI1->DR=mode;//md krokovn byte
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	SPI1->DR=mode;//md krokovn byte
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;
}
void GoTo(int motor,int pozice1, int pozice2, int nCS)//Go to command
{
	if(nCS==kamera)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else
	nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=96;//GoTo command byte
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
			;
	if(motor==1)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=96;//GoTo command byte
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
			;
	if(nCS==kamera)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else
	nCS_rameno_high;

	if(nCS==kamera)//vbr modulu - CS do "0"
			nCS_kamera_low;
		else
		nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=(pozice1>>16);//ABS_POS byte 2 - pozice byte 2
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
			;
	if(motor==1)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=(pozice2>>16);//ABS_POS byte 2 - pozice byte 2
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
			;
	if(nCS==kamera)//vbr modulu - CS do "1"
			nCS_kamera_high;
		else
		nCS_rameno_high;

	if(nCS==kamera)//vbr modulu - CS do "0"
			nCS_kamera_low;
		else
		nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=(pozice1>>8)&(0xFF);//ABS_POS byte 1 - pozice byte 1
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
			;
	if(motor==1)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=(pozice2>>8)&(0xFF);//ABS_POS byte 1 - pozice byte 1
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
			;
	if(nCS==kamera)//vbr modulu - CS do "1"
			nCS_kamera_high;
		else
		nCS_rameno_high;

	if(nCS==kamera)//vbr modulu - CS do "0"
			nCS_kamera_low;
		else
		nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=pozice1&0xFF;//ABS_POS byte 0 - pozice byte 0
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
			;
	if(motor==1)//vbr budie v modulu
		SPI1->DR=0;
	else
	SPI1->DR=pozice2&0xFF;//ABS_POS byte 0 - pozice byte 0
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
			;
	if(nCS==kamera)//vbr modulu - CS do "1"
			nCS_kamera_high;
		else
		nCS_rameno_high;
}
void ResetPos(int motor, int nCS)//Reset Pos command
{
	if(nCS==kamera)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else
		nCS_rameno_low;
	if(motor==2)//vbr budie v modulu
		SPI1->DR=0;
	else
		SPI1->DR=216;//Reset pos command byte
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
			;
	if(motor==1)//vbr budie v modulu
		SPI1->DR=0;
	else
		SPI1->DR=216;//Reset pos command byte
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
			;
	if(nCS==kamera)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else
		nCS_rameno_high;

}
void SetParam(int address, int data, int nCS)//Set param command, nepouv se
{
	int x=data;//vpoet dlky dat
	int pocet_bitu=1;
	x=data/2;
	while(x>=1)
	{
		x=x/2;
		pocet_bitu++;
	}
	int odeslat=0;

	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	SPI1->DR=address;//adresa registru
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	SPI1->DR=address;//adresa registru
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	if(pocet_bitu>8)//pprava dat k odesln
	{
		odeslat=(data>>(pocet_bitu-8));
	}
	else
	{
		odeslat=data;
	}

	if(nCS==1)//vbr modulu - CS do "0"
		nCS_kamera_low;
	else if(nCS==0)
		nCS_rameno_low;
	SPI1->DR=odeslat;//odesln dat byte 2
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	SPI1->DR=odeslat;//odesln dat byte 2
	while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
		;
	if(nCS==1)//vbr modulu - CS do "1"
		nCS_kamera_high;
	else if(nCS==0)
		nCS_rameno_high;

	int maska=0;
	if(pocet_bitu>8){//pprava dat k odesln
		maska=1;
		for(int i=0;i<(pocet_bitu-8-1);i++)
			maska=(maska<<1)+1;
		if(pocet_bitu>16)
		{
			odeslat=((data&maska)>>(pocet_bitu-16));
		}
		else
		{
			odeslat=((data&maska)<<(8-(pocet_bitu-8)));
		}
		if(nCS==1)//vbr modulu - CS do "0"
			nCS_kamera_low;
		else if(nCS==0)
			nCS_rameno_low;
		SPI1->DR=odeslat;//odesln dat byte 1
		while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
			;
		SPI1->DR=odeslat;//odesln dat byte 1
		while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
			;
		if(nCS==1)//vbr modulu - CS do "1"
			nCS_kamera_high;
		else if(nCS==0)
			nCS_rameno_high;

		if(pocet_bitu>16)
		{
			maska=1;//pprava dat k odesln
			for(int i=0;i<(pocet_bitu-16-1);i++)
				maska=(maska<<1)+1;
			odeslat=((data&maska)<<(16-(pocet_bitu-8)));
			if(nCS==1)//vbr modulu - CS do "0"
				nCS_kamera_low;
			else if(nCS==0)
				nCS_rameno_low;
			SPI1->DR=odeslat;//odesln dat byte 0
			while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
				;
			SPI1->DR=odeslat;//odesln dat byte 0
			while(!(SPI1->SR & SPI_SR_TXE)|| (SPI1->SR & SPI_SR_BSY))//ekn na odesln
				;
			if(nCS==1)//vbr modulu - CS do "1"
				nCS_kamera_high;
			else if(nCS==0)
				nCS_rameno_high;
		}
	}
}
char t[50];//pevn pole pro uloen zprvy z PC
int delka=0;//globln promnn pro dlku zprvy z PC
void USART_prijem()//pjem dat z PC
{	int i=0;
	int p1=0;
	int length=USART2->DR;//globln promnn pro dlku zprvy z PC, zrove pjem prvnho znaku
	length=length-48;//pevod z ASCII kdu
	while(!(USART2->SR & USART_SR_RXNE))//ekn na dal pjem
		;
	p1=USART2->DR;//peten znaku
	if(p1==';')//zjiovn jestli piel stednk
		;
	else//naten dalho znaku pro dlku
	{
		length=length*10+(p1-48);
		while(!(USART2->SR & USART_SR_RXNE))
			;
		p1=USART2->DR;
	}
	delka=length;//peklopen do globln promnn
	char text[length];//lokln pjmov pole
	for (int j = 0; j < sizeof(text); j++)//definovn hodnot pole
		text[j] = '0';
	while(length){//naten zbytku zprvy
		if(USART2->SR & USART_SR_RXNE){
			text[i]=USART2->DR;
			i++;
			length--;
		}
	}
	for(int j=0;j<sizeof(text);j++)//peklopen do globlnho pole
	t[j]=text[j];
}
void USART_send(char t)//odesln jednoho charakteru
{

	while(!(USART2->SR & USART_SR_TXE));//ekn na uvolnn odesln
	USART2->DR=t;

}
void USART_string(char *t)//odesln etzce
{
	while(*t){//odeln charakter po charaketeru
		USART_send(*t);
		t++;
	}
}
void USART_odeslat(int data)//odesln zprvy
{	char t[3];
for (int i = 0; i < sizeof(t); i++)
	t[i] = '0';
sprintf(t,"%d;",data);//vytvoen etezce, pravdpodobn rozen velikosti loklnho pole t
USART_string(t);
}
void USART_init()//inicializace USART
{
	GPIOA->MODER|=GPIO_MODER_MODER2_1;//AF - Alternativn funkce
	GPIOA->MODER|=GPIO_MODER_MODER3_1;//AF - Alternativn funkce
	GPIOA->OSPEEDR|=(3<<4);//nastaven rychlosti
	GPIOA->OSPEEDR|=(3<<6);//nastaven rychlosti
	GPIOA->AFR[0]|=(7<<8);//vbr AF
	GPIOA->AFR[0]|=(7<<12);//vbr AF
	RCC->APB1RSTR|=RCC_APB1RSTR_USART2RST;//reset periferie
	RCC->APB1RSTR&=~(RCC_APB1RSTR_USART2RST);
	RCC->APB1ENR|=RCC_APB1ENR_USART2EN;//povolen hodin
	USART2->BRR=0x1A1;//nastaven Baud rate
	USART2->CR1|=USART_CR1_RE|USART_CR1_TE;//konfigurace
	USART2->CR1|=USART_CR1_UE;//povolen perfierie
}
int main(void)//zatek programu
{
	int i = 0;

	LedInit();//inicializace LED
	SystemCoreClockUpdate();//inicializace systmovho asovae
	SysTick_Config(SystemCoreClock / 1000);
	SPIInit();//inicializace SPI
	USART_init();//inicializace USART

	GPIOB->MODER|=GPIO_MODER_MODER5_0;
	GPIOB->ODR&=~(GPIO_ODR_ODR_5);//reset budi motor
	GPIOB->ODR|=GPIO_ODR_ODR_5;

	while((GPIOC->IDR&(1<<1))==(1<<1))//pokej na zapnut modulu s budii
			;

	//vodn konfigurace
	int nabeh_budicu=tick;
	while((tick-nabeh_budicu)<5)//pokej na nbh vudi
		;
	GetStatus(kamera);//vyten statusu po resetu - kamera (pouze pro zhasnut LED)
	GetStatus(rameno);//vyten statusu po resetu - rameno (pouze pro zhasnut LED)

	Soft_HiZ(0,kamera);//uvolnn motor ped konfigurac (jen pojiujc pkaz)
	Soft_HiZ(2,rameno);//uvolnn motor ped konfigurac (jen pojiujc pkaz)
	SetMaxSpeed(20,kamera,0);//max rychlost - kamera
	SetMaxSpeed(2,rameno,2);//max rychlost - rameno
	//konec konfigurace


	int speed=0;
	int time=0;
	int vyber_motoru=3;
	int mkamera_X_smer=2;
	int mkamera_Y_smer=2;
	int m1_speed=0;
	int m2_speed=0;
	int nCS=0;
	int mrameno_smer=2;
	int spinac_X1_predchozi=1;
	int spinac_X1=1;
	int spinac_X2_predchozi=1;
	int spinac_X2=1;
	int spinac_Y1_predchozi=1;
	int spinac_Y1=1;
	int spinac_Y2_predchozi=1;
	int spinac_Y2=1;
	int spinac_rameno=1;
	int spinac_rameno_predchozi=1;
	int m1_pocet_kroku=0;
	int m2_pocet_kroku=0;
	int mkamera_X_pozice=0;
	int mkamera_Y_pozice=0;
	int mrameno_pozice=0;
	int aktualni_pozice_X=0;
	int aktualni_pozice_Y=0;
	int aktualni_pozice_rameno=0;

	//uveden do polohy 0 0 0
	int reset_poz=3;
	int x_reset=0;
	int y_reset=0;
	int r_reset=0;
	Run(0,0,0,5,5,kamera);//sputn behu kamery
	Run(2,2,0,0,5,rameno);//sputn behu ramena
	while(reset_poz!=0){//ekn na nulovou polohu vech os
		spinac_X1=(GPIOC->IDR&(1<<10));//ten spna
		spinac_Y2=(GPIOC->IDR&(1<<9));
		spinac_rameno=(GPIOC->IDR&(1<<11));
		if((spinac_X1==0)&&(spinac_X1_predchozi!=0)&&(x_reset==0))//zastaven a reset polohy osy x
		{
			SoftStop(2,kamera);
			ResetPos(2,kamera);
			x_reset=1;
			reset_poz--;
		}
		if((spinac_Y2==0)&&(spinac_Y2_predchozi!=0)&&(y_reset==0))//zastaven a reset polohy osy y
		{
			SoftStop(1,kamera);
			ResetPos(1,kamera);
			y_reset=1;
			reset_poz--;
		}
		if((spinac_rameno==0)&&(spinac_rameno_predchozi!=0)&&(r_reset==0))//zastaven a reset polohy ramena
		{
			SoftStop(2,rameno);
			ResetPos(2,rameno);
			r_reset=1;
			reset_poz--;
		}
		spinac_X1_predchozi=spinac_X1;//uloen pedchozch stav spna
		spinac_Y2_predchozi=spinac_Y2;
		spinac_rameno_predchozi=spinac_rameno;
	}
	//konec uveden do polohy 0 0 0

	ResetPos(0,kamera);//pojiujc reset pozice kamera
	ResetPos(2,rameno);//pojiujc reset pozice ramena
	while (1)//zatek hlavn smyky
	{
		spinac_X1=(GPIOC->IDR&(1<<10));//ten span
		spinac_X2=(GPIOC->IDR&(1<<8));
		spinac_Y1=(GPIOC->IDR&(1<<6));
		spinac_Y2=(GPIOC->IDR&(1<<9));
		spinac_rameno=(GPIOC->IDR&(1<<11));
		if((spinac_X1_predchozi==(1<<10))&&(spinac_X1==0)&&(mkamera_X_smer==0))//zastaven osy x od spnae X1
		{
			SoftStop(2,kamera);
		}
		if((spinac_X2_predchozi==(1<<8))&&(spinac_X2==0)&&(mkamera_X_smer==1))//zastaven osy x od spnae X2
		{
			SoftStop(2,kamera);
		}
		if((spinac_Y1_predchozi==(1<<6))&&(spinac_Y1==0)&&(mkamera_Y_smer==1))//zastaven osy y od spnae Y1
		{
			SoftStop(1,kamera);
		}
		if((spinac_Y2_predchozi==(1<<9))&&(spinac_Y2==0)&&(mkamera_Y_smer==0))//zastaven osy y od spnae Y2
		{
			SoftStop(1,kamera);
		}
		if((spinac_rameno_predchozi==(1<<11))&&(spinac_rameno==0)&&(mrameno_smer==0))//zastaven ramena od spnae
		{
			SoftStop(2,rameno);
		}
		if(USART2->SR & USART_SR_RXNE){//kontrola pijet zprvy z PC
			USART_prijem();//pjem zprvy
			//ten oznaen zprvy
			if((t[0]=='R')&&(t[1]=='P'))//Reset pozice, nco-48 -> pevod z ASCII
			{
				vyber_motoru=t[2]-48;
				nCS=t[3]-48;
				ResetPos(vyber_motoru,nCS);
			}
			else if(t[0]=='R')//Run, nco-48 -> pevod z ASCII
			{
				vyber_motoru=t[1]-48;
				nCS=t[6]-48;//nCS
				m1_speed=t[4]-48;//speed1
				m2_speed=t[5]-48;//speed2
				if(nCS==kamera){
					mkamera_X_smer=t[3]-48;
					mkamera_Y_smer=t[2]-48;
					if(((mkamera_X_smer==0)&&(spinac_X1==0))||((mkamera_X_smer==1)&&(spinac_X2==0)))//kontrola sprvnho smru osy x
						USART_string("Spatny smer osy X");//odesln chybov zprvy
					else if(((mkamera_Y_smer==0)&&(spinac_Y2==0))||((mkamera_Y_smer==1)&&(spinac_Y1==0)))//kontrola sprvnho smru osy y
						USART_string("Spatny smer osy Y");//odesln chybov zprvy
					else
					{
						USART_string("OK");//odesln potvrzujc zprvy
						Run(vyber_motoru,mkamera_Y_smer,mkamera_X_smer,m1_speed,m2_speed,nCS);//odesln pkazu pro kameru
					}
					}
				else if (nCS==rameno){
					mrameno_smer=t[3]-48;
					if((mrameno_smer==0)&&(spinac_rameno==0))//kontrola sprvnho smru ramena
						USART_string("Spatny smer ramena");//odesln chybov zprvy
					else{
						USART_string("OK");//odesln potvrzujc zprvy
						Run(vyber_motoru,0,mrameno_smer,m1_speed,m2_speed,nCS);//odesln pkazu pro rameno
						}
					}
			}
			else if(t[0]=='Z')//Soft HiZ, nco-48 -> pevod z ASCII
			{
				Soft_HiZ(t[1]-48,t[2]-48);//odesln pkazu
			}
			else if((t[0]=='S')&&(t[1]=='O'))//Set overcurrent detection, nepouito, proto pevn kamera
			{
				Set_OCD(kamera);
			}
			else if((t[0]=='S')&&(t[1]=='S')&&(t[2]=='T'))//Set stall detection, nepouito, proto pevn kamera
			{
				Set_Stall(kamera);
			}
			else if((t[0]=='S')&&(t[1]=='S'))//Set max speed
			{
				nCS=t[2]-48;
				vyber_motoru=t[3]-48;
				speed=t[4]-48;
				if(nCS==kamera)
					speed=(((Run_kamera_speeds[speed])<<8)+255)/1024;//peveden bhov rychlosti na rychlost maximln
				else if(nCS==rameno)
					speed=(((Run_rameno_speeds[speed])<<8)+255)/1024;//peveden bhov rychlosti na rychlost maximln

				SetMaxSpeed(speed,nCS,vyber_motoru);//odesln pkazu
			}
			else if((t[0]=='S')&&(t[1]=='M'))//Set step mode, nepouito, proto pevn kamera
			{
				SetStepMode(0,kamera);
			}
			else if(t[0]=='S')//Soft Stop
				SoftStop(t[1]-48,t[2]-48);//odesln pkazu
			else if((t[0]=='G')&&(t[1]=='P'))//Get param, u uivatele nepouito proto pevn nastaven
			{
				GetParam(33,t[2]-48);//pozice
				USART_odeslat(prijem1);
				USART_odeslat(prijem2);
				USART_odeslat(prijem3);
				USART_odeslat(prijem4);
				USART_odeslat(prijem5);
				USART_odeslat(prijem6);
			}
			else if((t[0]=='G')&&(t[1]=='T'))//GoTo
			{
				vyber_motoru=t[2]-48;
				nCS=t[3]-48;
				int strednik=0;
				if(nCS==kamera){
				for(int i=4;i<delka;i++)//ten pozice ze zprvy pro kameru
					{
						if(t[i]==';')
							{
								strednik++;
								if(strednik==2)
									break;
								i++;
							}
						if(strednik==0)
							mkamera_Y_pozice=mkamera_Y_pozice*10+(t[i]-48);
						else
							mkamera_X_pozice=mkamera_X_pozice*10+(t[i]-48);
					}
				GetParam(33,kamera);//zjitn aktuln pozice
				aktualni_pozice_X=(prijem2<<16)+(prijem4<<8)+prijem6;
				aktualni_pozice_Y=(prijem1<<16)+(prijem3<<8)+prijem5;
				if(mkamera_X_pozice>aktualni_pozice_X)//uren smru osy x
					mkamera_X_smer=1;
				else if(mkamera_X_pozice<aktualni_pozice_X)
					mkamera_X_smer=0;
				if(mkamera_Y_pozice>aktualni_pozice_Y)//uren smru osy y
					mkamera_Y_smer=1;
				else if(mkamera_Y_pozice<aktualni_pozice_Y)
					mkamera_Y_smer=0;
				if(((mkamera_X_smer==0)&&(spinac_X1==0))||((mkamera_X_smer==1)&&(spinac_X2==0)))//kontrola sprvnho smru osy x
					USART_string("Spatny smer osy X");//odesln chybov zprvy
				else if(((mkamera_Y_smer==0)&&(spinac_Y2==0))||((mkamera_Y_smer==1)&&(spinac_Y1==0)))//kontrola sprvnho smru osy y
					USART_string("Spatny smer osy Y");//odesln chybov zprvy
				else
				{
					USART_string("OK");//odesln potvrzujc zprvy
					GoTo(vyber_motoru,mkamera_Y_pozice,mkamera_X_pozice,nCS);//odesln pkazu pro kameru

				}
				mkamera_X_pozice=0;
				mkamera_Y_pozice=0;
				}
				else if(nCS==rameno)
				{
					for(int i=4;i<delka;i++)//ten pozice ze zprvy pro rameno
						{
							if(t[i]==';')
								{
									strednik++;
									if(strednik==2)
										break;
									i++;
								}
							if(strednik==0)
								;
							else
								mrameno_pozice=mrameno_pozice*10+(t[i]-48);
						}
					GetParam(33,rameno);//zjitn aktuln pozice
					aktualni_pozice_rameno=(prijem2<<16)+(prijem4<<8)+prijem6;
					if(mrameno_pozice>aktualni_pozice_rameno)//uren smru ramena
						mrameno_smer=1;
					else if(mrameno_pozice<aktualni_pozice_rameno)
						mrameno_smer=0;
					if((mrameno_smer==0)&&(spinac_rameno==0))//kontrola sprvnho smru ramena
						USART_string("Spatny smer ramena");//odesln chybov zprvy
					else
					{
						USART_string("OK");//odesln potvrzujc zprvy
						GoTo(vyber_motoru,0,mrameno_pozice,nCS);//odesln pkazu
										}
					mrameno_pozice=0;
				}

			}
			else if(t[0]=='G')//GetStatus
			{
				GetStatus(t[1]-48);
				USART_odeslat(prijem1);
				USART_odeslat(prijem2);
				USART_odeslat(prijem3);
				USART_odeslat(prijem4);
			}
			else if(t[0]=='M')//Move
			{
				vyber_motoru=t[1]-48;
				nCS=t[4]-48;
				int strednik=0;
				for(int i=5;i<delka;i++)//ten potu krok ze zprvy pro kameru
				{
					if(t[i]==';')
					{
						strednik++;
						if(strednik==2)
							break;
						i++;
					}
					if(strednik==0)
					m1_pocet_kroku=m1_pocet_kroku*10+(t[i]-48);
					else
					m2_pocet_kroku=m2_pocet_kroku*10+(t[i]-48);
				}
				if(nCS==kamera){
					mkamera_X_smer=t[3]-48;
					mkamera_Y_smer=t[2]-48;
					if(((mkamera_X_smer==0)&&(spinac_X1==0))||((mkamera_X_smer==1)&&(spinac_X2==0)))//kontrola sprvnho smru osy x
						USART_string("Spatny smer osy X");//odesln chybov zprvy
					else if(((mkamera_Y_smer==0)&&(spinac_Y2==0))||((mkamera_Y_smer==1)&&(spinac_Y1==0)))//kontrola sprvnho smru osy y
						USART_string("Spatny smer osy Y");//odesln chybov zprvy
					else
					{
						USART_string("OK");//odesln potvrzujc zprvy
						Move(vyber_motoru,mkamera_Y_smer,mkamera_X_smer,nCS,m1_pocet_kroku,m2_pocet_kroku);//odesln pkazu
					}
					}
				else if(nCS==rameno)
				{
					mrameno_smer=t[3]-48;
					if((mrameno_smer==0)&&(spinac_rameno==0))//kontrola sprvnho smru ramena
						USART_string("Spatny smer ramena");//odesln chybov zprvy
					else
					{
						USART_string("OK");//odesln potvrzujc zprvy
						Move(vyber_motoru,0,mrameno_smer,nCS,m1_pocet_kroku,m2_pocet_kroku);//odesln pkazu
					}
				}
				m1_pocet_kroku=0;
				m2_pocet_kroku=0;
			}
			for(int i=0;i<sizeof(t);i++)//vyitn pjmovho pole
				t[i]=0;
		}
		if((tick-time)>500)//blikn zelenou LED
		{
			if(GPIOA->ODR&0x20)
			{
				GPIOA->ODR&=~(GPIO_ODR_ODR_5);//zelen
			}
			else{
				GPIOA->ODR|=GPIO_ODR_ODR_5;
			}
			time=tick;
		}
		i++;
		spinac_X1_predchozi=spinac_X1;//uloen pedchozch stav spna
		spinac_X2_predchozi=spinac_X2;
		spinac_Y1_predchozi=spinac_Y1;
		spinac_Y2_predchozi=spinac_Y2;
		spinac_rameno_predchozi=spinac_rameno;
	}//konec hlavn smyky
}
